package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.client.ClientService;
import com.nisum.offertransactionservice.genericexception.GlobalApiGenericException;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.NullSource;
import org.junit.jupiter.params.provider.ValueSource;
import org.mockito.ArgumentMatchers;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import reactor.core.publisher.Mono;

import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.mockito.Mockito.when;

public class EndOfTransactionTest {

    @InjectMocks
    private EndOfTransactionService endOfTransactionService;

    @Mock
    private ClientService clientService;

    @BeforeEach
    public void setUp() throws Exception {
        MockitoAnnotations.initMocks(this);
    }


    @DisplayName("This test will  test the  endOfTransactionTest method ")
    @ParameterizedTest
    @ValueSource(strings={"86fd4146-0540-405b-b621-a95f4ccdfa0d"})
    public void endOfTransactionTest(String uuid) {

        when(clientService.getStringMono(ArgumentMatchers.any())).thenReturn(Mono.just("test"));
        assertNotNull(endOfTransactionService.endOfTransaction(uuid));

    }


    @DisplayName("This test will  test the  endOfTransactionTest method ")
    @ParameterizedTest
    @NullSource
    public void endOfTransactionNegTest(String uuid) {

        assertThrows(GlobalApiGenericException.class, () -> {
            endOfTransactionService.endOfTransaction(uuid);
        });
    }
}
